//Author Antonio-Gabriel Sturzu

#include<stdio.h>
#include<vector>
#include<string.h>
#include<time.h>
#define pb push_back
#define mp make_pair 
#define inf 50000001

using namespace std;

int main()
{
	int n,m,i,a,b,c,d[10005],min,nod=0,j;
	vector< pair<int,int> > v[10005];
	char viz[10005];
	clock_t start,stop;
	FILE *f=fopen("dijkstra2.in","r");

	fscanf(f,"%i%i",&n,&m);
	for(i=0;i<m;i++)
	{
		fscanf(f,"%i%i%i",&a,&b,&c);
		v[a].pb(mp(b,c));
	}
	fclose(f);

	memset(viz,0,sizeof(viz));
	start=clock();
	d[1]=0;
	for(i=2;i<=n;i++)
		d[i]=inf;
	
	for(;;)
	{
		min=inf;
		for(i=1;i<=n;i++)
		{
			if(viz[i]==0 && d[i]<min)
			{
				min=d[i];
				nod=i;
			}
		}
		if(min==inf)
			break;
		viz[nod]=1;
		for(j=0;j<(int) v[nod].size();j++)
		{
			if(v[nod][j].second+d[nod]<d[v[nod][j].first])
				d[v[nod][j].first]=v[nod][j].second+d[nod];
		}
	}
	stop=clock();
	printf("Au trecut %f secunde\n",(double) (stop-start)/CLOCKS_PER_SEC);

	f=fopen("dijkstra.out","w");
	for(i=2;i<=n;i++)
	{
		if(d[i]==inf)
			d[i]=0;
		fprintf(f,"%i ",d[i]);
	}
	fprintf(f,"%s","\n");
	fclose(f);
	return 0;
}
